-- small example program using luagzip
-- usage: luagziptest.lua <infile> <outfile>

local luagzip = dofile("luagzip.lua")

local args = {...}

if args then
	file = io.open(args[1])
else
	print("no input filename")
	return
end

local gzip = luagzip.new()

local offset = 0
local blocksize = 1024

if not args[2] then
	print("no output filename")
	return
end

local outfile = io.open(args[2], "w")
dsize = 0

while true do
	local inbuf = file:read(blocksize)
	if not inbuf then
		print("EOF")
		return
	end

	offset = offset + blocksize

	buf, err = gzip:decompress(inbuf)
	if not buf and err then
		print(err)
		return
	elseif buf then
		outfile:write(buf)
	else
		print("success")
		return
	end
end

outfile:close()
