-- example plugin using httplib and luagzip

local HTTP = dofile("httplib.lua")
local luagzip = dofile("luagzip.lua")

function http_gzip(url)
	local http = HTTP.new()

	local function http_cb(response)
		if response.status == 200 then
			local gzip = luagzip.new()
			local file = response.body.get()
			
			local outfile = ""
			local start = os.time()
			
			local pos = 1
			while pos <= #file do
				local chunk = file:sub(pos, pos + 1999)
				pos = pos + 2000

				local output, err = gzip:decompress(chunk)
				if not output and err then
					console_print("ERROR! "..err)
					return
				elseif output then
					outfile = outfile..output
				else
					console_print("done")
					break
				end
			end
			
			console_print("decoding time "..(os.time() - start))
			console_print("checksum "..SHA1(outfile))
		else
			console_print("an error occured")
		end
	end

	http.urlopen(url, http_cb)
end
